local _G = getfenv(0)
local gratuity = AceLibrary("Gratuity-2.0")
local SML = AceLibrary("SharedMedia-1.0")
local tablet = AceLibrary("Tablet-2.0")

local L = setmetatable({}, {__index = function(self, key) return key end})

ElkBuffBars = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "AceEvent-2.0", "FuBarPlugin-2.0")
ElkBuffBars:RegisterDB("ElkBuffBarsDB")
ElkBuffBars:RegisterDefaults("profile", {
	bargroups = {
		{
			["bars"] = {
				["icon"]				= "LEFT",											-- "LEFT", "RIGHT", false
				["iconcount"]			= true,												-- true, false
				["iconcountanchor"]		= "CENTER",											-- <anchor>
				["iconcountfont"]		= "Arial Narrow",									-- <SML:font>
				["iconcountfontsize"]	= 14,												-- <font size>
				["iconcountcolor"]		= {1, 1, 1},										-- <color set>
				["bar"]					= "Otravi",											-- <SML:statusbar>, false
				["barright"]			= false,											-- true, false
				["textTL"]				= "NAMERANKCOUNT",									-- false, "NAME", "NAMERANK", "NAMECOUNT", "NAMERANKCOUNT", "RANK", "COUNT", "TIMELEFT", "DEBUFFTYPE"
				["textTLfont"]			= "Friz Quadrata TT",								-- <SML:font>
				["textTLfontsize"]		= 14,												-- <font size>
				["textTLcolor"]			= {1, 1, 1},										-- <color set>
				["textTLalign"]			= "LEFT",											-- left, center, right
				["textTR"]				= "TIMELEFT",										-- false, "NAME", "NAMERANK", "NAMECOUNT", "NAMERANKCOUNT", "RANK", "COUNT", "TIMELEFT", "DEBUFFTYPE"
				["textTRfont"]			= "Friz Quadrata TT",								-- <SML:font>
				["textTRfontsize"]		= 14,												-- <font size>
				["textTRcolor"]			= {1, 1, 1},										-- <color set>
				["barcolor"]			= {0.3, 0.5, 1},									-- <color set>
				["barbgcolor"]			= {0, 0.5, 1},										-- <color set>
				["debufftypecolor"]		= true,												-- true, false
				["timeformat"]			= "CONDENSED",										-- "DEFAULT", "EXTENDED", "FULL", "SHORT", "CONDENSED"
				["width"]				= 350,
				["height"]				= 25,
			},
			["filter"] = {
				["type"] = {
					["BUFF"] = true,
					["TENCH"] = true,
					["TRACKING"] = true,
				}
			},
			sorting = "timeleft",						-- timeleft, timemax
			target = "player",							-- player, pet, target
			growup = false,								-- true, false
			barspacing = 0,								-- 0+
			anchortext = "BUFFS & Co.",					-- <string>
			anchorshown = false,						-- true, false
		},
		{
			["bars"] = {
				["icon"]				= "LEFT",											-- "LEFT", "RIGHT", false
				["iconcount"]			= true,												-- true, false
				["iconcountanchor"]		= "BOTTOMRIGHT",									-- <anchor>
				["iconcountfont"]		= "Arial Narrow",									-- <SML:font>
				["iconcountfontsize"]	= 14,												-- <font size>
				["iconcountcolor"]		= {1, 1, 1},										-- <color set>
				["bar"]					= "Charcoal",										-- <SML:statusbar>, false
				["barright"]			= true,												-- true, false
				["textTL"]				= "NAMERANK",										-- false, "NAME", "NAMERANK", "NAMECOUNT", "NAMERANKCOUNT", "RANK", "COUNT", "TIMELEFT", "DEBUFFTYPE"
				["textTLfont"]			= "Morpheus",										-- <SML:font>
				["textTLfontsize"]		= 20,												-- <font size>
				["textTLcolor"]			= {1, 1, 1},										-- <color set>
				["textTLalign"]			= "LEFT",											-- left, center, right
				["textTR"]				= "COUNT",											-- false, "NAME", "NAMERANK", "NAMECOUNT", "NAMERANKCOUNT", "RANK", "COUNT", "TIMELEFT", "DEBUFFTYPE"
				["textTRfont"]			= "Friz Quadrata TT",								-- <SML:font>
				["textTRfontsize"]		= 14,												-- <font size>
				["textTRcolor"]			= {1, 1, 1},										-- <color set>
				["textBL"]				= "DEBUFFTYPE",										-- false, "NAME", "NAMERANK", "NAMECOUNT", "NAMERANKCOUNT", "RANK", "COUNT", "TIMELEFT", "DEBUFFTYPE"
				["textBLfont"]			= "Friz Quadrata TT",								-- <SML:font>
				["textBLfontsize"]		= 14,												-- <font size>
				["textBLcolor"]			= {1, 1, 1},										-- <color set>
				["textBLalign"]			= "LEFT",											-- left, center, right
				["textBR"]				= "TIMELEFT",										-- false, "NAME", "NAMERANK", "NAMECOUNT", "NAMERANKCOUNT", "RANK", "COUNT", "TIMELEFT", "DEBUFFTYPE"
				["textBRfont"]			= "Friz Quadrata TT",								-- <SML:font>
				["textBRfontsize"]		= 14,												-- <font size>
				["textBRcolor"]			= {1, 1, 1},										-- <color set>
				["barcolor"]			= {1, 0, 0},										-- <color set>
				["barbgcolor"]			= {1, 0, 0},										-- <color set>
				["debufftypecolor"]		= true,												-- true, false
				["timeformat"]			= "CONDENSED",										-- "DEFAULT", "EXTENDED", "FULL", "SHORT", "CONDENSED"
				["width"]				= 350,
				["height"]				= 50,
			},
			["filter"] = {
				["type"] = {
					["DEBUFF"] = true,
				}
			},
			sorting = "timeleft",						-- timeleft, timemax
			target = "player",							-- player, pet, target
			growup = false,								-- true, false
			barspacing = 0,								-- 0+
			anchortext = "DEBUFFS",						-- <string>
			anchorshown = false,						-- true, false
			stickto = 1,								-- bargroup id
			stickside = "",								-- "LEFT", "RIGHT", ""
		},
		{
			["bars"] = {
				["icon"]				= "LEFT",											-- "LEFT", "RIGHT", false
				["iconcount"]			= true,												-- true, false
				["iconcountanchor"]		= "BOTTOMRIGHT",									-- <anchor>
				["iconcountfont"]		= "Arial Narrow",									-- <SML:font>
				["iconcountfontsize"]	= 14,												-- <font size>
				["iconcountcolor"]		= {1, 1, 1},										-- <color set>
				["bar"]					= "Steel",											-- <SML:statusbar>, false
				["barright"]			= false,											-- true, false
				["textTL"]				= "NAMERANK",										-- false, "NAME", "NAMERANK", "NAMECOUNT", "NAMERANKCOUNT", "RANK", "COUNT", "TIMELEFT", "DEBUFFTYPE"
				["textTLfont"]			= "Morpheus",										-- <SML:font>
				["textTLfontsize"]		= 20,												-- <font size>
				["textTLcolor"]			= {1, 1, 1},										-- <color set>
				["textTLalign"]			= "LEFT",											-- left, center, right
				["textTR"]				= "COUNT",											-- false, "NAME", "NAMERANK", "NAMECOUNT", "NAMERANKCOUNT", "RANK", "COUNT", "TIMELEFT", "DEBUFFTYPE"
				["textTRfont"]			= "Friz Quadrata TT",								-- <SML:font>
				["textTRfontsize"]		= 14,												-- <font size>
				["textTRcolor"]			= {1, 1, 1},										-- <color set>
				["textBL"]				= "DEBUFFTYPE",										-- false, "NAME", "NAMERANK", "NAMECOUNT", "NAMERANKCOUNT", "RANK", "COUNT", "TIMELEFT", "DEBUFFTYPE"
				["textBLfont"]			= "Friz Quadrata TT",								-- <SML:font>
				["textBLfontsize"]		= 14,												-- <font size>
				["textBLcolor"]			= {1, 1, 1},										-- <color set>
				["textBLalign"]			= "LEFT",											-- left, center, right
				["textBR"]				= "TIMELEFT",										-- false, "NAME", "NAMERANK", "NAMECOUNT", "NAMERANKCOUNT", "RANK", "COUNT", "TIMELEFT", "DEBUFFTYPE"
				["textBRfont"]			= "Friz Quadrata TT",								-- <SML:font>
				["textBRfontsize"]		= 14,												-- <font size>
				["textBRcolor"]			= {1, 1, 1},										-- <color set>
				["barcolor"]			= {1, 0, 0},										-- <color set>
				["barbgcolor"]			= {1, 0, 0},										-- <color set>
				["debufftypecolor"]		= true,												-- true, false
				["timeformat"]			= "CONDENSED",										-- "DEFAULT", "EXTENDED", "FULL", "SHORT", "CONDENSED"
				["width"]				= 350,
				["height"]				= 50,
			},
			["filter"] = {
				["type"] = {
					["BUFF"] = true,
					["DEBUFF"] = true,
				}
			},
			sorting = "timeleft",						-- timeleft, timemax
			target = "target",							-- player, pet, target
			growup = true,								-- true, false
			barspacing = 0,								-- 0+
			anchortext = "Target...",					-- <string>
			anchorshown = false,						-- true, false
		},
	},
	nameoverride = {
		BUFF = {},
		DEBUFF = {},
		TENCH = {},
		TRACKING = {},
	},
	typeoverride = {
		BUFF = {},
		DEBUFF = {},
		TENCH = {},
		TRACKING = {},
	},
})

local STICKTO_AREA = 25

local updates_disabled = false
local scan_happend = {}
scan_happend.player = false
scan_happend.pet = false
scan_happend.target = false
local old_hasMainHandEnchant, old_mainHandExpiration, old_mainHandCharges, old_hasOffHandEnchant, old_offHandExpiration, old_offHandCharges
ElkBuffBars.knownnames = {
	BUFF = {},
	DEBUFF = {},
	TENCH = {},
	TRACKING = {},
}

local AO_allopts
local AO_buffsettings
local AO_groupsettings

local SML_font = SML:List("font")
local SML_statusbar = SML:List("statusbar")

function ElkBuffBars:OnInitialize()
	local build = select(2, _G.GetBuildInfo())
	if not self.db.account.build or self.db.account.build ~= build then
		self.db.account.build = build
		self.db.account.maxtimes = {
			BUFF = {},
			DEBUFF = {},
			TENCH = {},
		}
	end
end

function ElkBuffBars:OnEnable()
	-- update known names
	self:UpdateKnownNames()
	-- create bargroups based on stored settings
	self:CreateBarGroups()
	
	-- register events
	self:RegisterBucketEvent("PLAYER_AURAS_CHANGED", .25)
	self:RegisterBucketEvent("PLAYER_TARGET_CHANGED", .25)
	self:RegisterBucketEvent("UNIT_AURA", .25)
	self:ScheduleRepeatingEvent(self.DoUpdates, .1, self)
	
	--
	self:ScanData_BUFF()
	self:ScanData_DEBUFF()
	self:ScanData_TENCH()
	self:ScanData_TRACKING()
end

function ElkBuffBars:OnDisable()
	-- recycle all bargroups
	self:RemoveBarGroups()
end


-- -----
-- cache bars
-- -----
local barcache = {}

function ElkBuffBars:GetBar()
	if #barcache > 0 then
		return table.remove(barcache, #barcache)
	else
		return EBB_Bar:new()
	end
end

function ElkBuffBars:RecycleBar(bar)
	bar:Reset()
	table.insert(barcache, bar)
end

-- -----
-- cache bargroups
-- -----
local bargroupcache = {}

function ElkBuffBars:GetBarGroup()
	if #bargroupcache > 0 then
		return table.remove(bargroupcache, #bargroupcache)
	else
		return EBB_BarGroup:new()
	end
end

function ElkBuffBars:RecycleBarGroup(bargroup)
	bargroup:Reset()
	table.insert(bargroupcache, bargroup)
end

-- -----
-- cache datatables
-- -----
local datatablecache = {}

local function GetDataTable()
	if #datatablecache > 0 then
		return table.remove(datatablecache, #datatablecache)
	else
		return {}
	end
end

local function RecycleDataTable(dt)
	table.insert(datatablecache, dt)
end

-- -----
-- known names
-- -----
ElkBuffBars.knownnames = {
	BUFF = {},
	DEBUFF = {},
	TENCH = {},
	TRACKING = {},
}

function ElkBuffBars:AddKnownName(type, name)
	if not self.knownnames[type][name] then
		self.knownnames[type][name] = true
		AO_buffsettings.args[type].args[name] = self:GetNameOptions(type, name)
	end
end

function ElkBuffBars:UpdateKnownNames()
	for type, data in pairs(self.db.profile.nameoverride) do
		for name in pairs(data) do
			self:AddKnownName(type, name)
		end
	end
	for type, data in pairs(self.db.profile.typeoverride) do
		for name in pairs(data) do
			self:AddKnownName(type, name)
		end
	end
end

-- -----
-- creation/removing of bargroups
-- -----
ElkBuffBars.bargroups = {}

function ElkBuffBars:CreateBarGroups()
	for k, v in pairs(self.bargroups) do
		self:RecycleBarGroup(v)
		self.bargroups[k] = nil
	end

	local bglayouts = self.db.profile.bargroups
	for k, v in ipairs(bglayouts) do
		self:AddBarGroup(v)
	end
	for k, v in ipairs(self.bargroups) do
		local layout = bglayouts[k]
		v:SetPosition()
		v:GetContainer():Show()
	end
end

function ElkBuffBars:RemoveBarGroups()
	for k, v in pairs(self.bargroups) do
		self:RecycleBarGroup(v)
		self.bargroups[k] = nil
		AO_groupsettings[k] = nil
	end
end

function ElkBuffBars:AddBarGroup(layout)
	if not layout then
		layout = {
		}
		table.insert(self.db.profile.bargroups, layout)
	end
	local bargroup = self:GetBarGroup()
	table.insert(self.bargroups, bargroup)
	layout.id = #self.bargroups
	bargroup:SetLayout(layout)
	table.insert(AO_groupsettings, self:GetGroupOptions(#self.bargroups))
end

function ElkBuffBars:RemoveBarGroup(id)
	table.remove(self.bargroups, id)
	for k, v in self.bargroups do
		local layout = v.layout
		layout.id = k
		if layout.stickto then
			if layout.stickto == id then
				-- the group we sticked to was removed
				local container = v:GetContainer()
				layout.stickto = nil
				container:ClearAllPoints()
				container:SetPoint("CENTER", UIParent, "CENTER", layout.x, layout.y)
				v:ToggleAnchor(true)
			elseif layout.stickto > id then
				layout.stickto = layout.stickto - 1
			end
		end
	end
	table.remove(AO_groupsettings)
end

-- -----
-- buff scanning
-- -----
ElkBuffBars.buffdata = {}
ElkBuffBars.debuffdata = {}
ElkBuffBars.tenchdata = {}
ElkBuffBars.trackingdata = {}
ElkBuffBars.targetbuffdata = {}
ElkBuffBars.targetdebuffdata = {}

function ElkBuffBars:PLAYER_AURAS_CHANGED()
	self:ScanData_BUFF()
	self:ScanData_DEBUFF()
	self:ScanData_TRACKING()
	
	self:DoUpdates()
end

function ElkBuffBars:PLAYER_TARGET_CHANGED()
	self:ScanData_Unit_BUFF("target")
	self:ScanData_Unit_DEBUFF("target")

	self:DoUpdates()
end

function ElkBuffBars:UNIT_AURA(args)
	local scanned_pet = false
	local scanned_target = false
	for arg in pairs(args) do
		if not scanned_pet and arg == "pet" then
			self:ScanData_Unit_BUFF("pet")
			self:ScanData_Unit_DEBUFF("pet")
		end
		if not scanned_target and arg == "target" then
			self:ScanData_Unit_BUFF("target")
			self:ScanData_Unit_DEBUFF("target")
		end
	end

	self:DoUpdates()
end

function ElkBuffBars:ScanData_BUFF()
	updates_disabled = true
	local maxtimes = self.db.account.maxtimes.BUFF
	for k, v in pairs(self.buffdata) do
		RecycleDataTable(v)
		self.buffdata[k] = nil
	end
	local i = 1
	while true do
		local buffIndex, untilCancelled = GetPlayerBuff(i, "HELPFUL")
		if buffIndex == 0 then break end
		local timeleft = GetPlayerBuffTimeLeft(buffIndex)
		local timemax = timeleft
		local name, rank = GetPlayerBuffName(buffIndex)
		self:AddKnownName("BUFF", name)
		local tname = name..(rank and (" "..rank) or "")
		if rank then
			_, _, rank = string.find(rank, RANK.." (%d+)")
		end
		if maxtimes[tname] and timemax < maxtimes[tname] then
			timemax = maxtimes[tname]
		else
			maxtimes[tname] = timemax
		end

		local dt = GetDataTable()
		dt.id				= buffIndex
		dt.name				= self.db.profile.nameoverride.BUFF[name] or name
		dt.realname			= name
		dt.rank				= rank and tonumber(rank) or nil
		dt.type				= self.db.profile.typeoverride.BUFF[name] or "BUFF"
		dt.realtype			= "BUFF"
		dt.debufftype		= nil
		dt.timeleft			= timeleft
		dt.timemax			= timemax
		dt.untilcancelled	= (untilCancelled == 1) and true or nil
		dt.charges			= GetPlayerBuffApplications(buffIndex)
		dt.icon				= GetPlayerBuffTexture(buffIndex)
		
		table.insert(self.buffdata, dt)
		i = i + 1
	end
	scan_happend.player = true
	updates_disabled = false
end

function ElkBuffBars:ScanData_DEBUFF()
	updates_disabled = true
	local maxtimes = self.db.account.maxtimes.DEBUFF
	for k, v in pairs(self.debuffdata) do
		RecycleDataTable(v)
		self.debuffdata[k] = nil
	end
	local i = 1
	while true do
		local buffIndex, untilCancelled = GetPlayerBuff(i, "HARMFUL")
		if buffIndex == 0 then break end
		local timeleft = GetPlayerBuffTimeLeft(buffIndex)
		local timemax = timeleft
		local name, rank = GetPlayerBuffName(buffIndex)
		self:AddKnownName("DEBUFF", name)
		local tname = name..(rank and (" "..rank) or "")
		if rank then
			_, _, rank = string.find(rank, RANK.." (%d+)")
		end
		if maxtimes[tname] and timemax < maxtimes[tname] then
			timemax = maxtimes[tname]
		else
			maxtimes[tname] = timemax
		end

		local dt = GetDataTable()
		dt.id				= buffIndex
		dt.name				= self.db.profile.nameoverride.DEBUFF[name] or name
		dt.realname			= name
		dt.rank				= rank and tonumber(rank) or nil
		dt.type				= self.db.profile.typeoverride.DEBUFF[name] or "DEBUFF"
		dt.realtype			= "DEBUFF"
		dt.debufftype		= GetPlayerBuffDispelType(buffIndex)
		dt.timeleft			= timeleft
		dt.timemax			= timemax
		dt.untilcancelled	= (untilCancelled == 1) and true or nil
		dt.charges			= GetPlayerBuffApplications(buffIndex)
		dt.icon				= GetPlayerBuffTexture(buffIndex)
		
		table.insert(self.debuffdata, dt)
		i = i + 1
	end
	scan_happend.player = true
	updates_disabled = false
end

function ElkBuffBars:ScanData_TENCH()
	updates_disabled = true
	local maxtimes = self.db.account.maxtimes.TENCH
	for k, v in pairs(self.tenchdata) do
		RecycleDataTable(v)
		self.tenchdata[k] = nil
	end
	local hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges = GetWeaponEnchantInfo()
	if ( hasMainHandEnchant ) then
		local timeleft = mainHandExpiration / 1000
		local timemax = timeleft
	
		local id = GetInventorySlotInfo("MainHandSlot")
		local name, rank = self:GetTempBuffName(id)
		self:AddKnownName("TENCH", name)
		local tname = name..(rank and (" "..rank) or "")
		if rank then
			_, _, rank = string.find(rank, RANK.." (%d+)")
		end
		if maxtimes[tname] and timemax < maxtimes[tname] then
			timemax = maxtimes[tname]
		else
			maxtimes[tname] = timemax
		end
		local dt = GetDataTable()
		dt.id				= id
		dt.name				= self.db.profile.nameoverride.TENCH[name] or name
		dt.realname			= name
		dt.rank				= rank and tonumber(rank) or nil
		dt.type				= self.db.profile.typeoverride.TENCH[name] or "TENCH"
		dt.realtype			= "TENCH"
		dt.debufftype		= nil
		dt.timeleft			= timeleft
		dt.timemax			= timemax
		dt.untilcancelled	= nil
		dt.charges			= mainHandCharges
		dt.icon				= GetInventoryItemTexture("player", id)
		
		table.insert(self.tenchdata, dt)
	end
	if ( hasOffHandEnchant ) then
		local timeleft = offHandExpiration / 1000
		local timemax = timeleft

		local id = GetInventorySlotInfo("SecondaryHandSlot")
		local name, rank = self:GetTempBuffName(id)
		local tname = name..(rank and (" "..rank) or "")
		self:AddKnownName("TENCH", name)
		if rank then
			_, _, rank = string.find(rank, RANK.." (%d+)")
		end
		if maxtimes[tname] and timemax < maxtimes[tname] then
			timemax = maxtimes[tname]
		else
			maxtimes[tname] = timemax
		end
		local dt = GetDataTable()
		dt.id				= id
		dt.name				= self.db.profile.nameoverride.TENCH[name] or name
		dt.realname			= name
		dt.rank				= rank and tonumber(rank) or nil
		dt.type				= self.db.profile.typeoverride.TENCH[name] or "TENCH"
		dt.realtype			= "TENCH"
		dt.debufftype		= nil
		dt.timeleft			= timeleft
		dt.timemax			= timemax
		dt.untilcancelled	= nil
		dt.charges			= mainHandCharges
		dt.icon				= GetInventoryItemTexture("player", id)
		
		table.insert(self.tenchdata, dt)
	end
	scan_happend.player = true
	updates_disabled = false
end

function ElkBuffBars:ScanData_TRACKING()
	updates_disabled = true
	for k, v in pairs(self.trackingdata) do
		RecycleDataTable(v)
		self.trackingdata[k] = nil
	end
	local icon = GetTrackingTexture()
	if icon then
		name = self:GetTrackingName()
		self:AddKnownName("TRACKING", name)
		local dt = GetDataTable()
		dt.id				= id
		dt.name				= self.db.profile.nameoverride.TRACKING[name] or name
		dt.realname			= name
		dt.rank				= nil
		dt.type				= self.db.profile.typeoverride.TRACKING[name] or "TRACKING"
		dt.realtype			= "TRACKING"
		dt.debufftype		= nil
		dt.timeleft			= 1
		dt.timemax			= 1
		dt.untilcancelled	= true
		dt.charges			= 1
		dt.icon				= icon
		
		table.insert(self.trackingdata, dt)
	end
	scan_happend.player = true
	updates_disabled = false
end

function ElkBuffBars:ScanData_Unit_BUFF(unit)
	local unitvar = unit.."buffdata"
	if not self[unitvar] then return end
	updates_disabled = true
	for k, v in pairs(self[unitvar]) do
		RecycleDataTable(v)
		self[unitvar][k] = nil
	end
	local i = 1
	while true do
		local name, rank, icon, count = UnitBuff(unit, i)
		if not icon then break end
		self:AddKnownName("BUFF", name)
		if rank then
			_, _, rank = string.find(rank, RANK.." (%d+)")
		end

		local dt = GetDataTable()
		dt.id				= i
		dt.name				= self.db.profile.nameoverride.BUFF[name] or name
		dt.realname			= name
		dt.rank				= rank and tonumber(rank) or nil
		dt.type				= (self.db.profile.typeoverride.BUFF[name] or "BUFF")
		dt.realtype			= "BUFF"
		dt.debufftype		= nil
		dt.timeleft			= 1
		dt.timemax			= 1
		dt.untilcancelled	= true
		dt.charges			= count
		dt.icon				= icon
		
		table.insert(self[unitvar], dt)
		i = i + 1
	end
	scan_happend[unit] = true
	updates_disabled = false
end

function ElkBuffBars:ScanData_Unit_DEBUFF(unit)
	local unitvar = unit.."debuffdata"
	if not self[unitvar] then return end
	updates_disabled = true
	for k, v in pairs(self[unitvar]) do
		RecycleDataTable(v)
		self[unitvar][k] = nil
	end
	local i = 1
	while true do
		local name, rank, icon, count, debuffType = UnitDebuff(unit, i);
		if not icon then break end
		self:AddKnownName("DEBUFF", name)
		if rank then
			_, _, rank = string.find(rank, RANK.." (%d+)")
		end

		local dt = GetDataTable()
		dt.id				= i
		dt.name				= self.db.profile.nameoverride.DEBUFF[name] or name
		dt.realname			= name
		dt.rank				= rank and tonumber(rank) or nil
		dt.type				= (self.db.profile.typeoverride.DEBUFF[name] or "DEBUFF")
		dt.realtype			= "DEBUFF"
		dt.debufftype		= debuffType
		dt.timeleft			= 1
		dt.timemax			= 1
		dt.untilcancelled	= true
		dt.charges			= count
		dt.icon				= icon
		
		table.insert(self[unitvar], dt)
		i = i + 1
	end
	scan_happend[unit] = true
	updates_disabled = false
end

function ElkBuffBars:GetTempBuffName(id)
	gratuity:SetInventoryItem("player", id)
	local _, _, buffname = gratuity:Find("^(.+) %(%d+ [^%)]+%)$")
	if buffname then
		return buffname
	end
	local itemlink = GetInventoryItemLink("player", id)
	if itemlink then
		name = GetItemInfo(itemlink)
		return name or "Weapon "..id
	end
	return "Weapon "..id
end

function ElkBuffBars:GetTrackingName()
	gratuity:SetTrackingSpell()
	local name = gratuity:GetLine(1)
	return name or "Tracking..."
end

--
--
--
function ElkBuffBars:DoUpdates()
	if updates_disabled then return end
	
	for k, v in pairs(self.buffdata) do
		if not v.untilcancelled then
			local timeleft = GetPlayerBuffTimeLeft(v.id)
			if timeleft > v.timeleft then
				self:ScanData_BUFF()
				break
			end
			v.timeleft = timeleft
		end
	end

	for k, v in pairs(self.debuffdata) do
		if not v.untilcancelled then
			local timeleft = GetPlayerBuffTimeLeft(v.id)
			if timeleft > v.timeleft then
				self:ScanData_DEBUFF()
				break
			end
			v.timeleft = timeleft
		end
	end

	-- check for changed weaponbuffs
	local hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges = GetWeaponEnchantInfo()
	if hasMainHandEnchant ~= old_hasMainHandEnchant or (mainHandExpiration or 0) > (old_mainHandExpiration or 0) or mainHandCharges ~= old_mainHandCharges
		or hasOffHandEnchant ~= old_hasOffHandEnchant or (offHandExpiration or 0) > (old_offHandExpiration or 0) or offHandCharges ~= old_offHandCharges then
		self:ScanData_TENCH()
	else
		for k, v in pairs(self.tenchdata) do
			if v.id == GetInventorySlotInfo("MainHandSlot") then
				v.timeleft = mainHandExpiration / 1000
			end
			if v.id == GetInventorySlotInfo("SecondaryHandSlot") then
				v.timeleft = offHandExpiration / 1000
			end
		end
	end
	old_hasMainHandEnchant = hasMainHandEnchant
	old_mainHandExpiration = mainHandExpiration
	old_mainHandCharges = mainHandCharges
	old_hasOffHandEnchant = hasOffHandEnchant
	old_offHandExpiration = offHandExpiration
	old_offHandCharges = offHandCharges
	
	-- if we did a scan, update bar data
	if scan_happend.player or scan_happend.pet or scan_happend.target then
		for k, v in pairs(self.bargroups) do
			v:UpdateData(scan_happend)
		end
		for k in pairs(scan_happend) do
			scan_happend[k] = false
		end
	else
		for k, v in pairs(self.bargroups) do
			v:UpdateTimeleft()
		end
	end
end

function ElkBuffBars:StickGroup(bargroup)
	local layout = bargroup.layout
	local id = layout.id
	local growup = layout.growup
	local container = bargroup:GetContainer()
	local base_y = growup and container:GetBottom() or container:GetTop()
	local base_left = container:GetLeft()
	local base_right = container:GetRight()
	layout.stickto = nil
	self:Print("Sticking bargroup", id)
	for k, v in pairs(self.bargroups) do
		local comp_container = v:GetContainer()
		local comp_y = growup and comp_container:GetTop() or comp_container:GetBottom()
		if math.abs(comp_y - base_y) < STICKTO_AREA then
			-- we are on the same y-area
			local rel_left = base_left - comp_container:GetLeft()
			local rel_right = base_right - comp_container:GetRight()
			if rel_left >= - STICKTO_AREA and rel_right <= STICKTO_AREA then
				self:Print(" - sticking to bargroup ", k)
				-- we are also on the same x-area
				-- check if we would loop-stick to ourself
				local parent = v
				local hasloop = false
				while parent.layout.stickto do
					if parent.layout.stickto == id then
						self:Print(" - LOOP FOUND!")
						hasloop = true
						break
					end
					parent = self.bargroups[parent.layout.stickto]
				end
				if not hasloop then
					self:Print(" - SUCESS!")
					-- we have found a valid group to stick to
					layout.stickto = k
					if math.abs(rel_left) <= STICKTO_AREA and math.abs(rel_right) > STICKTO_AREA then
						layout.stickside = "LEFT"
					elseif math.abs(rel_left) > STICKTO_AREA and math.abs(rel_right) <= STICKTO_AREA then
						layout.stickside = "RIGHT"
					else
						layout.stickside = ""
					end
					container:ClearAllPoints()
					container:SetPoint((growup and "BOTTOM" or "TOP")..(layout.stickside or ""), comp_container, (growup and "TOP" or "BOTTOM")..(layout.stickside or ""))
					return true
				end
			end
		end
	end
	return false
end

-- -----
-- FuBar stuff
-- -----
ElkBuffBars.hasIcon = false
ElkBuffBars.hasNoColor = true
ElkBuffBars.clickableTooltip = true

function ElkBuffBars:OnTextUpdate()
	self:SetText("ElkBuffBars")
end

function ElkBuffBars:OnTooltipUpdate()
	local cat = tablet:AddCategory(
		'columns', 2,
		'text', L["bargroup"],
		'text2', L["type"],
		'hideBlankLine', true,
		'showWithoutChildren', true
	)
	for k, v in ipairs(self.bargroups) do
		cat:AddLine(	"text",		tostring(k)..". "..(v.layout.anchortext or "???"),
						"text2",	v.layout.target,
						"hasCheck",	true,
						"checked",	v.layout.anchorshown,
						"func",		"ToggleAnchor",
						"arg1",		v
					)
	end
end

-- -----
-- AceOption table
-- -----
AO_buffsettings = {
	type = "group", name = L["Buffs Settings"], desc = L["Change name and type for known buffs"], args = {
		BUFF = {
			type = "group", name = "BUFF", desc = "BUFF", args = {},
		},
		DEBUFF = {
			type = "group", name = "DEBUFF", desc = "DEBUFF", args = {},
		},
		TENCH = {
			type = "group", name = "TENCH", desc = "TENCH", args = {},
		},
		TRACKING = {
			type = "group", name = "TRACKING", desc = "TRACKING", args = {},
		},
	}
}

AO_groupsettings = {}

AO_allopts = {
	type = "group", args = {
		buffsettings = AO_buffsettings,
		groupsettings = {
			type = "group", name = L["Group Settings"], desc = L["Changes the settings for the bargroups"], args = AO_groupsettings,
		}
	}
}

function ElkBuffBars:GetNameOptions(type, name)
	return {
		type = "group", name = name, desc = name, args = {
			name = {
				type = "text", name = L["Shown Name"], desc = L["Sets the name to show"], usage = "none",
				get = function() return ElkBuffBars.db.profile.nameoverride[type][name] or "" end,
				set = function(v) ElkBuffBars.db.profile.nameoverride[type][name] = v ~= "" and v or nil end,
			},
			type = {
				type = "text", name = L["New Type"], desc = L["Sets the new type"],
				get = function() return ElkBuffBars.db.profile.typeoverride[type][name] or "" end,
				set = function(v) ElkBuffBars.db.profile.typeoverride[type][name] = (v ~= "" and v ~= type) and v or nil end,
				validate = {BUFF = "BUFF", DEBUFF = "DEBUFF", TENCH = "TENCH", TRACKING = "TRACKING", [""] = L["default"]},
			}
		}
	}
end

local groupoptionscache = {}
function ElkBuffBars:GetGroupOptions(id)
	if not groupoptionscache[id] then
		groupoptionscache[id] = {
			type = "group", name = (L["Group %d"]):format(id), desc = (L["Settings for Group %d"]):format(id), args = {
				anchorshown = {
					type = "toggle", name = L["Show Anchor"], desc = L["Toggles Anchor"],
					get = function() return ElkBuffBars.db.profile.bargroups[id].anchorshown end,
					set = function() ElkBuffBars.bargroups[id]:ToggleAnchor() end
				},
				anchortext = {
					type = "text", name = L["Name"], desc = L["Sets the group's name"], usage = "",
					get = function() return ElkBuffBars.db.profile.bargroups[id].anchortext end,
					set = function(v)
							local bg = ElkBuffBars.bargroups[id]
							bg.layout.anchortext = v
							if bg.layout.anchorshown then
								bg:ToggleAnchor(true)
							end
						end,
				},
				bars = {
					type = "group", name = L["Bar Layout"], desc = L["Sets the layout for this group's bars"], args = {
						bar = {
							type = "text", name = L["Bar Texture"], desc = L["Sets the bar texture"],
							get = function() return ElkBuffBars.db.profile.bargroups[id].bars.bar end,
							set = function(v)
									local bg = ElkBuffBars.bargroups[id]
									bg.layout.bars.bar = v
									bg:SetLayout()
								end,
							validate = SML_statusbar,
						},
						barright = {
							type = "toggle", name = L["Bar Direction LTR"], desc = L["Toggles if the bar depletes from left to right"],
							get = function() return ElkBuffBars.db.profile.bargroups[id].bars.barright end,
							set = function(v)
									local bg = ElkBuffBars.bargroups[id]
									bg.layout.bars.barright = v
									bg:SetLayout()
								end,
						},
						icon = {
							type = "text", name = L["Icon"], desc = L["Sets icon showing"],
							get = function() return ElkBuffBars.db.profile.bargroups[id].bars.icon end,
							set = function(v)
									local bg = ElkBuffBars.bargroups[id]
									bg.layout.bars.icon = v
									bg:SetLayout()
								end,
							validate = {[false] = L["hide"], ["LEFT"] = "Left Side", ["RIGHT"] = "Right Side"},
						}, -- "LEFT", "RIGHT", false
						iconcount = {
							type = "toggle", name = L["Icon - Count - Show"], desc = L["Toggles showing of buff stacks on the icon"],
							get = function() return ElkBuffBars.db.profile.bargroups[id].bars.iconcount end,
							set = function(v)
									local bg = ElkBuffBars.bargroups[id]
									bg.layout.bars.iconcount = v
									bg:SetLayout()
								end,
						}, -- true, false
						iconcountanchor = {
							type = "text", name = L["Icon - Count - Anchor"], desc = L["Sets the anchor for the buff stacks on the icon"],
							get = function() return ElkBuffBars.db.profile.bargroups[id].bars.iconcountanchor end,
							set = function(v)
									local bg = ElkBuffBars.bargroups[id]
									bg.layout.bars.iconcountanchor = v
									bg:SetLayout()
								end,
							validate = {"TOPLEFT", "TOP", "TOPRIGHT", "LEFT", "CENTER", "RIGHT", "BOTTOMLEFT", "BOTTOM", "BOTTOMRIGHT"},
						}, -- <anchor>
						iconcountfont = {
							type = "text", name = L["Icon - Count - Font"], desc = L["Sets the font for the buff stacks on the icon"],
							get = function() return ElkBuffBars.db.profile.bargroups[id].bars.iconcountfont end,
							set = function(v)
									local bg = ElkBuffBars.bargroups[id]
									bg.layout.bars.iconcountfont = v
									bg:SetLayout()
								end,
							validate = SML_font,
						}, -- <SML:font>
						iconcountfontsize =  {
							type = "range", name = L["Icon - Count - Font Size"], desc = L["Sets the font size for the buff stacks on the icon"],
							min = 4, max = 32, step = 1,
							get = function() return ElkBuffBars.db.profile.bargroups[id].bars.iconcountfontsize end,
							set = function(v)
									local bg = ElkBuffBars.bargroups[id]
									bg.layout.bars.iconcountfontsize = tonumber(v)
									bg:SetLayout()
								end,
								}, -- <font size>
--						iconcountcolor = {
--						}, -- <color set>
					}
				},
				barspacing = {
					type = "range", name = L["Bar Spacing"], desc = L["Sets gap between bars"],
					min = 0, max = 50, step = 1,
					get = function() return ElkBuffBars.db.profile.bargroups[id].barspacing end,
					set = function(v)
							local bg = ElkBuffBars.bargroups[id]
							bg.layout.barspacing = tonumber(v)
							bg:UpdateBarPositions()
						end,
				},
				filter = {
					type = "group", name = L["Filter"], desc = L["Sets the buffs to show"], args = {
						type = {
							type = "group", name = L["Type"], desc = L["Sets which types of buffs to show"], args = {
								BUFF = {
									type = "toggle", name = L["BUFF"], desc = L["Show BUFF"],
									get = function() return ElkBuffBars.db.profile.bargroups[id].filter.type.BUFF or false end,
									set = function(v)
											local bg = ElkBuffBars.bargroups[id]
											bg.layout.filter.type.BUFF = v or nil
											bg:UpdateData({[bg.layout.target] = true})
										end
								},
								DEBUFF = {
									type = "toggle", name = L["DEBUFF"], desc = L["Show DEBUFF"],
									get = function() return ElkBuffBars.db.profile.bargroups[id].filter.type.DEBUFF or false end,
									set = function(v)
											local bg = ElkBuffBars.bargroups[id]
											bg.layout.filter.type.DEBUFF = v or nil
											bg:UpdateData({[bg.layout.target] = true})
										end
								},
								TENCH = {
									type = "toggle", name = L["TENCH"], desc = L["Show TENCH"],
									get = function() return ElkBuffBars.db.profile.bargroups[id].filter.type.TENCH or false end,
									set = function(v)
											local bg = ElkBuffBars.bargroups[id]
											bg.layout.filter.type.TENCH = v or nil
											bg:UpdateData({[bg.layout.target] = true})
										end
								},
								TRACKING = {
									type = "toggle", name = L["TRACKING"], desc = L["Show TRACKING"],
									get = function() return ElkBuffBars.db.profile.bargroups[id].filter.type.TRACKING or false end,
									set = function(v)
											local bg = ElkBuffBars.bargroups[id]
											bg.layout.filter.type.TRACKING = v or nil
											bg:UpdateData({[bg.layout.target] = true})
										end
								},
							},
						},
					},
				},
				growup = {
					type = "toggle", name = L["Grow up"], desc = L["Toggles direction of buffs"],
					get = function() return ElkBuffBars.db.profile.bargroups[id].growup end,
					set = function(v)
							local bg = ElkBuffBars.bargroups[id]
							bg.layout.growup = v
							bg.layout.stickto = nil
							bg.layout.stickside = nil
							bg:SetLayout()
							bg:SetPosition()
						end
				},
				sorting = {
					type = "text", name = L["Sorting"], desc = L["Sets sorting of buffs"],
					get = function() return ElkBuffBars.db.profile.bargroups[id].sorting end,
					set = function(v)
							local bg = ElkBuffBars.bargroups[id]
							bg.layout.sorting = v
							bg:UpdateData({[bg.layout.target] = true})
						end,
					validate = {"timeleft", "timemax"},
				},
				target = {
					type = "text", name = L["Target"], desc = L["Sets whos buffs to show"],
					get = function() return ElkBuffBars.db.profile.bargroups[id].target end,
					set = function(v)
							local bg = ElkBuffBars.bargroups[id]
							bg.layout.target = v
							bg:UpdateData({[v] = true})
						end,
					validate = {"pet", "player", "target"},
				},
			}
		}
	end
	return groupoptionscache[id]
end

ElkBuffBars:RegisterChatCommand({"/ebbs"}, AO_allopts)
ElkBuffBars.OnMenuRequest = AO_allopts
